unit UnitClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RxRichEd, Gauges, ScktComp, ComCtrls;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    Gauge1: TGauge;
    RxRichEdit1: TRxRichEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure Jornal(txt: string; fst : TFontStyle; clr : TColor = clBlack);
    procedure ClientSocket1Connect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
  private
    Receiving : Boolean;
    cmd : TStringList;
    fName : string;
    fSize : Int64;
    fs : TFileStream;
    { Private declarations }
  public
    { Public declarations }
  end;

const
  bSize : Integer = 4000;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.FormShow(Sender: TObject);
begin
ClientSocket1.Active := True;
Receiving := False;
cmd := TStringList.Create;
fSize := 0;
fName := '';
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if ClientSocket1.Active then ClientSocket1.Active := False;
if Assigned(cmd) then cmd.Free;
end;



procedure TForm1.ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
var
  nRead : Integer;
  rBuf : Pointer;
begin
//       ,    
//         
if not Receiving then //  -  
  begin
      cmd.Text := Socket.ReceiveText;

      fName := cmd.Strings[0];
      fSize := StrToInt64(cmd.Strings[1]);
      Jornal('  ' + QuotedStr(cmd.Strings[0]), fsItalic);
      Jornal('  ' + QuotedStr(cmd.Strings[1]), fsBold);

      Gauge1.MinValue := 0;
      Gauge1.Progress := 0;
      Gauge1.MaxValue := fSize;
      Jornal('------------------------------------------', Unassigned);

      //            
      Receiving := True;
      fs := TFileStream.Create(fName, fmCreate);

      Gauge1.Progress := 0;
      //     
      cmd.Clear;
      cmd.Add('send');
      cmd.Add(fName);
      Socket.SendText(cmd.Text);
  end
else //   
  begin
    repeat
      Socket.Lock;
      //      
      GetMem(rBuf, bSize + 1);
      //   nRead =   
      nRead := Socket.ReceiveBuf(rBuf^, bSize);
      //    ,     
      if nRead > 0 then
        begin
          //fs.Seek(0, soFromEnd);
          fs.WriteBuffer(rBuf^, nRead);
          Gauge1.Progress := fs.Size;
        end;
      FreeMem(rBuf);
      Socket.Unlock;
      Application.ProcessMessages;
    until (nRead <= 0);
    //    ,         
    if fs.Size = fSize then
       begin
          Receiving := False;
          fs.Free;
          Jornal(' !', Unassigned, clGreen);
       end;
  end;
end;


//      [ ,  ,  ]
procedure TForm1.Jornal(txt: string; fst : TFontStyle; clr : TColor);
var
  time : string;
  totallen, curlen, sstart : Integer;
begin
if txt = '' then Exit;
time := '[' + DateTimeToStr(now) + '] ';
RxRichEdit1.Lines.Add(time+txt);
RxRichEdit1.SelStart := Length(RxRichEdit1.Lines.Text) - Length(time+txt) - RxRichEdit1.Lines.Count - 1;
RxRichEdit1.SelLength := Length(time+txt);
RxRichEdit1.SelAttributes.Color := clr;
if fst <> Unassigned then RxRichEdit1.SelAttributes.Style := RxRichEdit1.SelAttributes.Style + [fst];
end;


procedure TForm1.ClientSocket1Connect(Sender: TObject; Socket: TCustomWinSocket);
begin
Jornal('>    [' + Socket.RemoteAddress + ']', Unassigned, clGreen);
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Jornal('<    [' + Socket.RemoteAddress + ']', Unassigned, clRed);
end;

end.
