unit UnitServer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Gauges, RxRichEd, Mask, rxToolEdit, ScktComp;

type
  TForm1 = class(TForm)
    edt1: TFilenameEdit;
    RxRichEdit1: TRxRichEdit;
    Gauge1: TGauge;
    btn1: TButton;
    ServerSocket1: TServerSocket;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn1Click(Sender: TObject);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Jornal(txt: string; fst : TFontStyle; clr : TColor = clBlack);
    procedure SendFileSocket(fName : string);
    procedure Progress(prg, maxprg : Integer);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    fs : TFileStream;
    cmd : TStringList;
    CancelSend : Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  // bSize -     .
  //      
  // ,       100     8000
  //   .
  bSize : Integer = 4000;
  // SleepTime -      
  //    3   
  //    ,    
  //       
  SleepTime : ShortInt = 3;
  btnNameSend : string[4] = 'Send';
  btnNameCancel : string[6] = 'Cancel';

implementation

{$R *.dfm}

//    
procedure TForm1.Jornal(txt: string; fst : TFontStyle; clr : TColor);
var
  time : string;
begin
if txt = '' then Exit;
time := '[' + DateTimeToStr(now) + '] ';
RxRichEdit1.Lines.Add(time+txt);
RxRichEdit1.SelStart := Length(RxRichEdit1.Lines.Text) - Length(time+txt) - RxRichEdit1.Lines.Count - 1;
RxRichEdit1.SelLength := Length(time+txt);
RxRichEdit1.SelAttributes.Color := clr;
if fst <> Unassigned then RxRichEdit1.SelAttributes.Style := RxRichEdit1.SelAttributes.Style + [fst];
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
ServerSocket1.Active := True;
if ServerSocket1.Active then Jornal(' ', Unassigned, clGreen);
CancelSend := False;
btn1.Caption := btnNameSend;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : Integer;
begin
//   
for i := ServerSocket1.Socket.ActiveConnections - 1 downto 0 do
        ServerSocket1.Socket.Connections[i].Close;
if ServerSocket1.Active then ServerSocket1.Active := False;
end;






procedure TForm1.btn1Click(Sender: TObject);
var
  getfsize : TFileStream;
begin
if ServerSocket1.Socket.ActiveConnections = 1 then
  begin
    if btn1.Caption = btnNameSend then
      begin
        if FileExists(edt1.Text) then
            begin
              cmd.Clear;
              getfsize := TFileStream.Create(edt1.Text, fmOpenRead);
              cmd.Add(ExtractFileName(edt1.Text));
              cmd.Add(IntToStr(getfsize.Size));
              getfsize.Free;

              //     
              //       
              //   cmd (TStringList)
              ServerSocket1.Socket.Connections[0].SendText(cmd.Text);
            end;
      end
    else
      begin
         CancelSend := True;
         Jornal('   ', Unassigned, clRed);
      end;
  end;
end;




procedure TForm1.ServerSocket1ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
// cmd     formcreate
cmd := TStringList.Create;
Jornal('>  : [' + Socket.RemoteAddress + ']', Unassigned, clGreen);
end;



procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
if Assigned(cmd) then cmd.Free;
Jornal('<  : [' + Socket.RemoteAddress + ']', Unassigned, clGray);
end;


//    [ ; ,      ]
procedure TForm1.SendFileSocket(fName: string);
var
  nSend : Integer;
  sBuf : Pointer;
begin
try
    if CancelSend then Exit;
    btn1.Caption := btnNameCancel;
    nSend := 0;

    //       
    fs := TFileStream.Create(edt1.Text, fmOpenRead);
    //    ,     
    fs.Position := 0;

    //   
    Progress(fs.Position, fs.Size);

    Jornal('  ' + QuotedStr(ExtractFileName(edt1.Text)), fsItalic);
    Jornal('  ' + QuotedStr(IntToStr(fs.Size)), fsBold);

    repeat
       //    ,  
       if CancelSend then Break;
       //   (.)(.)
       GetMem(sBuf, bSize + 1);
       //    (bSize)  
       nSend := fs.Read(sBuf^, bSize);
       //    ,   
       if nSend > 0 then
         begin
           ServerSocket1.Socket.Connections[0].SendBuf(sBuf^, nSend);
           //    
           Progress(fs.Position, fs.Size);
           //     
           Sleep(SleepTime);
         end;
       //   (.)(.)
       FreeMem(sBuf);
       Application.ProcessMessages;
    until nSend <= 0; //     1      fs

    //     ,   
    if not CancelSend then Jornal(' !', fsBold, clGreen);
finally
    if Assigned(fs) then fs.Free;
    btn1.Caption := btnNameSend;
    if CancelSend then CancelSend := False;
end;
end;


//    
procedure TForm1.Progress(prg, maxprg: Integer);
begin
Gauge1.Progress := prg;
Gauge1.MaxValue := maxprg;
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject; Socket: TCustomWinSocket);
begin
    cmd.Text := Socket.ReceiveText;
    //      fName
    if cmd.Strings[0] = 'send' then
      begin
         Jornal(' [' + socket.RemoteAddress + ']    ' + QuotedStr(cmd.Strings[1]), Unassigned);

         //   
         if (ExtractFileName(edt1.Text) = cmd.Strings[1]) then SendFileSocket(edt1.Text);
      end;
end;

end.
